------------------
--  Flacko 2010 -
-- v0.1          -
-- 21/09/2010    -
------------------

-------------------------------
local goalmessages =
{
	{
		"GOOAAL!",
		"%1 scores for his team!",
		"%1 makes another goal for %6 that are now %8 goals!",
		"%1 keeps scoring for %6 that are now celebrating!",
		"%1 scores an epic goal, being this one his %2 one!",
		"%9 just couldn't see that one coming",
		"%1 scores again leaving both teams at %12 goals from each other!",
		"Ladies and gentlemen, now that's a goal! %1 is now the %3 best scorer on the field!",
		"%1 scores at the %13 minutes of the match, being this one his %2 goal!"
	},
	--Auto goal
	{
		"What the hell happened there?",
		"Oh my god, I can't believe it!!",
		"What are you doing, %1?",
		"%9 won't even need to move as long as %6 are going to score goals for them...",
		"What? Oh my god, this is the %4 auto goal from %1!",
		"%1 scores an auto goal, he's now the %5 player who made the most auto goals!",
	}
}
local teamnames =
{
	--Short
	{"T","CT"},
	--Long
	{"Terrorists","Counter-Terrorists"}
}
-------------------------------

ball_spawn_point = {x=0, y=0}

ball = {
	xacc = 0,
	yacc = 0,
	xvel = 0,
	yvel = 0,
	x = 0,
	y = 0,
	img = 0,
	lt = 0,
	ingame = false,
}
redgoalpos ={}
bluegoalpos={}
goalcount = {0,0}
minutes_playing = 0

function destroy_ball()
	if ball.img ~= 0 then freeimage(ball.img) end
	ball.ingame = false
end

function spawn_ball()
	if ball.img ~= 0 then
		freeimage(ball.img)
	end
	ball.x = (ball_spawn_point.x+0.5)*32
	ball.y = (ball_spawn_point.y+0.5)*32
	ball.xacc = 0
	ball.yacc = 0
	ball.xvel = 0
	ball.yvel = 0
	local id = image("gfx/sprites/ball.bmp",0,0,0)
	imagepos(id,ball.x,ball.y,0)
	ball.img = id
	lt = 0
	ball.ingame = true
end

function kickball(angle,strength,momentum,id)
	ball.xvel = math.cos(angle)*strength
	ball.yvel = math.sin(angle)*strength
	ball.xacc = math.cos(angle)*momentum
	ball.yacc = math.sin(angle)*momentum
	ball.lt = id
end

function loadgoalpositions()
	for tx=0, map("xsize") do
		for ty=0, map("ysize") do
			if entity(tx,ty,"exists") then
				if entity(tx,ty,"name") == "rednet" then
					table.insert(redgoalpos,{x = tx, y = ty})
				elseif entity(tx,ty,"name") == "bluenet" then
					table.insert(bluegoalpos,{x = tx, y = ty})
				elseif entity(tx,ty,"name") == "ballstart" then
					ball_spawn_point.x = tx
					ball_spawn_point.y = ty
				end
			end
		end
	end
end

function checkifgoal()
	local b = ball
	local rgp = redgoalpos
	local btx = math.floor((b.x+b.xvel)/32)
	local bty = math.floor((b.y+b.yvel)/32)
	for i=1, #rgp do
		if btx == rgp[i].x then
			if bty == rgp[i].y then
				isgoal(2) --Ball is in red net, blue team scores!
				return 1
			end
		end
	end
	local bgp = bluegoalpos
	for i=1,#bgp do
		if btx == bgp[i].x then
			if bty == bgp[i].y then
				isgoal(1) --ball is in blue net, red team scores!
				return 1
			end
		end
	end
end



function isgoal(t)
	goalcount[t] = goalcount[t] +1
	local scorer = ball.lt
	
	local tomsg
	
	if player(scorer,"team") ~= t then --Auto goal
		tomsg = goalmessages[2][math.random(1,#goalmessages[2])]
		parse("setdeaths " ..scorer .. " "..player(scorer,"deaths")+1)
	else --Goal
		tomsg = goalmessages[1][math.random(1,#goalmessages[1])]
		parse("setscore " .. scorer .. " "..player(scorer,"score")+1)
	end
	
	
	local function get_player_rank(id,param)
		local t = player(0,"table")
		local c = 1
		for i=1,#t do
			if player(t[i],param) > player(id,param) then
				c = c+1
			end
		end
		return c
	end
	
	local function giveformat(s)
		local t={
			player(scorer,"name"),			--%1 name

			player(scorer,"score"),			--%2 player goals

			get_player_rank(scorer,"score"),	--%3 scorer ranking(more goals better rank)

			player(scorer,"deaths"),		--%4 Player auto goals
			
			get_player_rank(scorer,"deaths"),	--%5 Player auto goal ranking
			
			teamnames[2][player(scorer,"team")],	--%6 scorer's team name (long)
			
			teamnames[1][player(scorer,"team")],	--%7 scorer's team name (short)

			goalcount[player(scorer,"team")],	--%8 scorer's team goals
			
			teamnames[2][3-player(scorer,"team")],	--%9 other team's name (long)

			teamnames[2][3-player(scorer,"team")],	--%10 other team's name (short)
			
			goalcount[3-player(scorer,"team")],	--%11 other team's goals

			math.abs(goalcount[1]-goalcount[2]),	--%12 goal difference between teams
			
			minutes_playing,			--%13 minutes passed since roundstart
		}
		return t[tonumber(s)]
	end
	tomsg = string.gsub(tomsg,"%%(%d*)",giveformat)
	
	local color = "000064255"
	if t == 1 then
		color= "255000000"
	end
	updatescorecount()
	msg(color..tomsg)
	destroy_ball()
	timer(3500, "spawn_ball")
end

function formatrot(r)
	return math.rad(r-90)
end

function getdist(x1,y1,x2,y2)
	return math.sqrt(math.pow(x1-x2,2) + math.pow(y1-y2,2))
end

function math.round(x)
	return math.floor(x+0.5)
end

function updatescorecount()
	parse('hudtxt 1 "T - CT" 320 20 1')
	parse('hudtxt 2 "'..goalcount[1]..'    '..goalcount[2]..'" 320 50 1')
end

loadgoalpositions()
spawn_ball()

addhook("startround","_startround")
function _startround()
	goalcount[1] = 0
	goalcount[2] = 0
	minutes_playing = 0
	spawn_ball()
end

addhook("spawn","_spawn")
function _spawn()
	return "x"
end

addhook("always","_always")
function _always()
	if ball.ingame then
		local t = player(0,"tableliving")
		for k,id in pairs(t) do
			local px = player(id,"x")
			local py = player(id,"y")
		
			if getdist(px,py,ball.x,ball.y) < 24 then
				--local angle = math.atan2(ball.y-py,ball.x-px)
				--Un commenting the above line (and commenting the line under this one) will change the control of the ball
				local angle = formatrot(player(id,"rot"))
				kickball(angle,player(id,"speedmod")*0.35+3.45,0,id)
			end
		end
	
		checkifgoal()
	
		if not tile(math.floor((ball.x-24+ball.xvel)/32), math.floor(ball.y/32),"walkable") or not tile(math.floor((ball.x+24+ball.xvel)/32), math.floor(ball.y/32),"walkable") then
			ball.xacc = -ball.xacc
			ball.xvel = -ball.xvel
		end
		if not tile(math.floor(ball.x/32), math.floor((ball.y-24+ball.yvel)/32),"walkable") or not tile(math.floor(ball.x/32), math.floor((ball.y+24+ball.yvel)/32),"walkable") then
			ball.yacc = -ball.yacc
			ball.yvel = -ball.yvel		
		end

		ball.xacc = ball.xacc*0.85
		ball.yacc = ball.yacc*0.85
	
		ball.xvel = ball.xvel*0.95 + ball.xacc
		ball.yvel = ball.yvel*0.95 + ball.yacc
		if ball.xvel > 32 then ball.xvel = 32 elseif ball.xvel < -32 then ball.xvel = -32 end
		if ball.yvel > 32 then ball.yvel = 32 elseif ball.yvel < -32 then ball.yvel = -32 end
	
		ball.y = ball.y + ball.yvel
		ball.x = ball.x + ball.xvel
	
		imagepos(ball.img,ball.x,ball.y,0)
	end
end

addhook("join","_join")
function _join(id)
	updatescorecount()
end

addhook("attack2","_attack2")
function _attack2(id)
	_attack(id,22,0)
end

addhook("attack","_attack")
function _attack(id,s,m)
	local speed = s or 2
	local momentum = m or 2
	local angle = formatrot(player(id,"rot"))
	local pointx = player(id,"x")+math.cos(angle)*24
	local pointy = player(id,"y")+math.sin(angle)*24
	if getdist(pointx, pointy, ball.x, ball.y) < 32 then
		kickball(angle,speed,momentum,id)
	end
end

addhook("hit","_hit")
function _hit()
	return 1
end
addhook("buy","_buy")
function _buy()
	return 1
end

addhook("minute","_minute")
function _minute()
	minutes_playing = minutes_playing + 1
end